      program I2d_H0 ! Bernd Berg March 25 2002. Compile with ../make77.
C 2d Ising model: Energy histogram from naive sampling.
      include '../../Libs/Fortran/implicit.sta'
      include '../../Libs/Fortran/constants.par'
      parameter(iuo=6,iud=10,isd1=1,isd2=2,ndat=1 000 000)
      include 'lat.par'
      include 'potts.par'
      include '../../Libs/Fortran_par/common_lat.f'
      include '../../Libs/Fortran_par/common_potts.f'
      dimension ix(nd)
      include 'lat.dat'
C
      write(iuo,'(" I2d_H0: nla =",5I4)') nla 
      call rmaset(iuo,iud,isd1,isd2,'ranmar.d')
      call lat_init(ms,nd,ipf,ipb,nla,ix)
      call potts_act_tab(idel,nqm1)
      call razero(ha,izero,mlink)
      do idat=1,ndat
        call potts_ran(ista,ms,nq)
        call potts_act(ista,ipf,idel,ms,nqm1,nd,iact)
        ha(iact)=ha(iact)+one
        iE=2*iact-mlink
        if(ndat*((10*idat)/ndat).eq.(10*idat))
     &    write(iuo,'(" idat,iact,iE:",3I10)') idat,iact,iE
      end do
C
      open(iud,file='I2d_H0.d',form='formatted',status='unknown')
      do iact=0,mlink
        iE=mlink-2*iact
        es=(iE*one)/(ms*one)
        p=ha(iact)/ndat
        pe=sqrt( p*(one-p)/(ndat-1) ) ! Binomial error bar.
        he=ndat*pe
        h=ha(iact)
        if(h.gt.half) write(iud,'(I10,5G14.5)') iE,es,p,pe,h,he
      end do
      close(iud)
C
      cfile="             " ! Not used.
      STOP
      END


      include '../../Libs/Fortran/rmaset.f'
      include '../../Libs/Fortran/ranmar.f'
      include '../../Libs/Fortran/rmasave.f'
      include '../../Libs/Fortran/ipointer.f'
      include '../../Libs/Fortran/ixcor.f'
      include '../../Libs/Fortran/isfun.f'
      include '../../Libs/Fortran/lat_init.f'
      include '../../Libs/Fortran/nsfun.f'
      include '../../Libs/Fortran/potts_act.f'
      include '../../Libs/Fortran/potts_act_tab.f'
      include '../../Libs/Fortran/potts_ran.f'
      include '../../Libs/Fortran/razero.f'
