      program pottsH0 ! Bernd Berg Oct 9 2006. Compile with ../make77.
C Potts models: Energy histogram from naive sampling.
      include '../../Libs/Fortran/implicit.sta'
      character cd*1,cq*2,cl*3
      include '../../Libs/Fortran/constants.par'
      include 'lat.par'
      include 'potts.par'
      include 'mc.par'
      include '../../Libs/Fortran_par/common_lat.f'
      include '../../Libs/Fortran_par/common_potts.f'
      dimension ix(nd)
      include 'lat.dat'
      data iact/0/, ha/(mlink+1)*zero/
      ltest=.true.
      ltest=.false.
      if(ltest) stop "pottsH0: ltest."
C
      write(iuo,'(/,"pottsH0 sampling:")') 
      write(iuo,'(" nd,nq,nrpt,nmeas =",3I6,I12)') nd,nq,nrpt,nmeas
      write(cd,'(I1.1)') nd
      write(cq,'(I2.2)') nq
      write(cl,'(I3.3)') nla(1)
      call rmaset(iuo,iud1,iseed1,iseed2,'ranmar.d')
      call lat_init(ms,nd,ipf,ipb,nla,ix)
      call potts_act_tab(idel,nqm1)
      open(iud1,file="p"//cd//"d"//cq//"q"//cl//".D",
     &     form="unformatted",status="unknown")
      write(iud1) beta,nd,nq,nla,mlink,nequi,nrpt,nmeas,iseed1,iseed2
      do irpt=1,nrpt
        call write_progress(iud2,"irpt,iact,ha:",irpt,iact,ha(mlink))
        call razero(ha,izero,mlink)
        do idat=1,nmeas
          call potts_ran(ista,ms,nq)
          call potts_act(ista,ipf,idel,ms,nqm1,nd,iact)
          ha(iact)=ha(iact)+one
        end do
        write(iuo,'(" irpt,iact,ha:",2I12,G14.5)') irpt,iact,ha(mlink)
        write(iud1) ha,one,irpt
      end do
      close(iud1)
C
      write(iuo,'("pottsH0: All done.")') 
      stop
      end


      include '../../Libs/Fortran/rmaset.f'
      include '../../Libs/Fortran/ranmar.f'
      include '../../Libs/Fortran/rmasave.f'
      include '../../Libs/Fortran/ipointer.f'
      include '../../Libs/Fortran/ixcor.f'
      include '../../Libs/Fortran/isfun.f'
      include '../../Libs/Fortran/lat_init.f'
      include '../../Libs/Fortran/nsfun.f'
      include '../../Libs/Fortran/potts_act.f'
      include '../../Libs/Fortran/potts_act_tab.f'
      include '../../Libs/Fortran/potts_ran.f'
      include '../../Libs/Fortran/razero.f'
      include '../../Libs/Fortran/write_progress.f'
