      SUBROUTINE BOOTSTRP(DAT1,NDAT,DAT2,NBTR,QTL,NQ) 
C Bernd Berg June 3 2005. 
C Generates bootstrap sample of the mean and calculates some q-tiles.
C DAT1(NDAT): Data array.
C DAT2(NBTR): Bootstrap array for mean value estimates.
C QTL(NQ):    Array for q-tiles.
      include '../../Libs/Fortran/implicit.sta'
      include '../../Libs/Fortran/constants.par'
      DIMENSION DAT1(NDAT), DAT2(NBTR), QTL(NQ) 
C
      DO I=1,NBTR
      X=ZERO
        DO J=1,NDAT
          IRAN=1+INT(NDAT*RMAFUN())
          X=X+DAT1(IRAN)
        END DO
      DAT2(I)=X/NDAT
      END DO       
C
      CALL HEAPSORT(NBTR,DAT2)
      N=NQ/2
      DO I=1,N
        II=I+I-1
        CALL QTILES(NBTR,DAT2,QTL(II),XQ1,XQ2)
        QTL(II)  =XQ1
        QTL(II+1)=XQ2
      END DO  
C
      RETURN
      END
