# set term pos eps enhanced defaultplex "Helvetica" 26
# set output '2dI_ts.eps'
# set title "2d Ising Model time series on an 80 x 80 lattice"
set xlabel "Sweeps"
set ylabel "e_{0s}"
set xrange [-1:201]
set yrange [-2:0]
set key 170,-0.15
plot 'potts_ts.d' using 1:2 title 'S: Random  Start' with line 1,\
     'potts_ts.d' using 1:3 title 'S: Ordered Start' with line 3,\
     'potts_tsr.d' using 1:2 title 'R: Random  Start' with line 4,\
     'potts_tsr.d' using 1:3 title 'R: Ordered Start' with line 5,\
     '2dI_ts_ferdi.d' using 1:2 title 'Exact' with line 2
pause -1
