      program potts_ts ! Bernd Berg, Dec 17 2000.
C Potts time series (ts) with systematic Metropolis updating.
      include '../../Libs/Fortran/implicit.sta'
      include '../../Libs/Fortran/constants.par'
      include 'lat.par'
      include 'mc.par'
      include 'potts.par'
      include '../../Libs/Fortran_par/common_lat.f'
      include '../../Libs/Fortran_par/common_potts.f'
      include 'lat.dat'
      dimension es_ts(0:nequi,2),act(0:nequi,2)
C
C Initialize Potts Metropolis MC:
      lpr=.true.
      call potts_init(lpr)
C
      write(iuo,'(/,1X,"Results: iequi,es,act on potts_ts.d.")')
      open(iud1,file='potts_ts.d',form='formatted',status='unknown')
      do irpt=1,2
        if(irpt.eq.2) call potts_order(ista,iact,nd,ms,1)
c       if(irpt.eq.2) call potts_act(ista,ipf,idel,ms,nqm1,nd,iact)
        do iequi=0,nequi
          if(iequi.ge.1) call potts_met
          act(iequi,irpt)=(iact*one)/(mlink*one)
          es_ts(iequi,irpt)=two*nd/(one*nq)-2*nd*act(iequi,irpt)
          if(irpt.eq.2) write(iud1,'(1I10,4F15.6)') 
     &      iequi,(es_ts(iequi,i),i=1,2),(act(iequi,i),i=1,2)
        end do
      end do
      close(iud1)
C
      stop
      end

      include '../../Libs/Fortran_par/potts_init.f'
      include '../../Libs/Fortran_par/potts_met.f'

      include '../../Libs/Fortran/ipointer.f'
      include '../../Libs/Fortran/isfun.f'
      include '../../Libs/Fortran/ixcor.f'
      include '../../Libs/Fortran/lat_init.f'
      include '../../Libs/Fortran/nsfun.f'

      include '../../Libs/Fortran/potts_act.f'
      include '../../Libs/Fortran/potts_act_tab.f'
      include '../../Libs/Fortran/potts_order.f'
      include '../../Libs/Fortran/potts_ran.f'
      include '../../Libs/Fortran/potts_wght.f'
      include '../../Libs/Fortran/razero.f'

      include '../../Libs/Fortran/ranmar.f'
      include '../../Libs/Fortran/rmaset.f'
      include '../../Libs/Fortran/rmasave.f'

