      program potts_ts_r ! Bernd Berg Dec 15 2000.
C Potts time series (ts) with random Metropolis updating.
      include '../../Libs/Fortran/implicit.sta'
      include '../../Libs/Fortran/constants.par'
      include 'lat.par'
      include 'mc.par'
      include 'potts.par'
      include '../../Libs/Fortran_par/common_lat.f'
      include '../../Libs/Fortran_par/common_potts.f'
      include 'lat.dat'
      dimension es_ts(0:nequi,2)
C
C Initialize Potts Metropolis MC:
      lpr=.true.
      call potts_init(lpr)
C
      write(iuo,'(/,1X,"Results: iequi,iact,iE,es on potts_ts.d.")')
      open(iud1,file='potts_tsr.d',form='formatted',status='unknown')
      do irpt=1,2
        if(irpt.eq.2) call potts_order(ista,iact,nd,ms,1)
c       if(irpt.eq.2) call potts_act(ista,ipf,idel,ms,nqm1,nd,iact)
        do iequi=0,nequi
          if(iequi.ge.1) call potts_met_r
          iE=-2*iact+mlink
          es_ts(iequi,irpt)=(iE*ONE)/(ms*ONE)
          if(irpt.eq.2)
     &    write(iud1,'(1I10,2G18.6)') iequi,(es_ts(iequi,i),i=1,2)
        end do
      end do
      close(iud1)
C
      stop
      end

      include '../../Libs/Fortran_par/potts_init.f'
      include '../../Libs/Fortran_par/potts_met_r.f'

      include '../../Libs/Fortran/ipointer.f'
      include '../../Libs/Fortran/isfun.f'
      include '../../Libs/Fortran/ixcor.f'
      include '../../Libs/Fortran/lat_init.f'
      include '../../Libs/Fortran/nsfun.f'

      include '../../Libs/Fortran/potts_act.f'
      include '../../Libs/Fortran/potts_act_tab.f'
      include '../../Libs/Fortran/potts_order.f'
      include '../../Libs/Fortran/potts_ran.f'
      include '../../Libs/Fortran/potts_wght.f'
      include '../../Libs/Fortran/razero.f'

      include '../../Libs/Fortran/ranmar.f'
      include '../../Libs/Fortran/rmaset.f'
      include '../../Libs/Fortran/rmasave.f'

