      program I2d_rwght ! Bernd Berg March 28 2005. Compile: ../make77.
C 2d Ising model: Energy histogram from re-weighting of naive sampling.
      include '../../Libs/Fortran/implicit.sta'
      include '../../Libs/Fortran/constants.par'
      parameter(iuo=6,iud=10,beta0=0.40d0)
      include 'lat.par'
      include 'potts.par'
      include '../../Libs/Fortran_par/common_lat.f'
      include '../../Libs/Fortran_par/common_potts.f'
      dimension hae(0:mlink),hb(0:mlink),hbe(0:mlink)
      write(iuo,'(/," I2d_rwght: beta0,mlink:",F12.8,I10)') beta0,mlink
C
      idat=0
      call razero(ha,0,mlink)
      call razero(hae,0,mlink)
      open(iud,file='I2d_H0.d',form='formatted',status='old')
1     read(iud,*,end=2) iE,es,p,pe,h,he
        idat=idat+1
        iact=-(iE-mlink)/2
        if(idat.eq.1) iamin=iact
        ha(iact)=h
        hae(iact)=he
      go to 1
2     iamax=iact
      close(iud)
      ndat=idat
C
      call potts_rwght(mlink,ha,hae,zero,beta0,hb,hbe)
      open(iud,file='I2d_rw4.d',form='formatted',status='unknown')
      do iact=iamin,iamax,2
        iE=-2*iact+mlink
        es=iE/(ms*one)
        if(ha(iact).gt.half) 
     &    write(iud,'(I10,3G15.6)') iE,es,hb(iact),hbe(iact)
      end do
      close(iud)
      actlm=potts_actl(mlink,hb)
      es=-4*actlm+two
      write(iuo,'(/," Reweighted: actlm,es =",2G14.5,/)') actlm,es
c
      STOP
      END


      include '../../Libs/Fortran/potts_rwght.f'
      include '../../Libs/Fortran/razero.f'
      include '../../Libs/Fortran/rmaset.f'
      include '../../Libs/Fortran/ranmar.f'
      include '../../Libs/Fortran/rmasave.f'
      include '../../Libs/Fortran/ipointer.f'
      include '../../Libs/Fortran/ixcor.f'
      include '../../Libs/Fortran/isfun.f'
      include '../../Libs/Fortran/lat_init.f'
      include '../../Libs/Fortran/nsfun.f'
      include '../../Libs/Fortran/potts_act.f'
      include '../../Libs/Fortran/potts_actl.f'
      include '../../Libs/Fortran/potts_act_tab.f'
      include '../../Libs/Fortran/potts_ran.f'
