      program ana_bias ! Bernd Berg Oct 23 2006. Compile with ../make77.
C Potts models: Analysis of the reweighitng process for naive sampling.
      include '../../Libs/Fortran/implicit.sta'
      include '../../Libs/Fortran/constants.par'
c     parameter(iuo=6,iud=9,njob=3, Cferdi=0.812515D00)
      parameter(iuo=6,iud=9,njob=10 000, Cferdi=0.812515D00)
      dimension Cam(njob),Came(njob),Cjm(njob),Cmm(njob),Cjme(njob)
      ltest=.true.
      ltest=.false.
      if(ltest) stop "ana_bias ltest."
C
      write(iuo,'(/," Cferdi =",8X,F10.6)') Cferdi
      open(iud,file='prod_bias.D',form='unformatted',status='unknown')
      read(iud) Cam,Came,Cjm,Cmm,Cjme
      close(iud)
      call steb0(njob,Cam,Camm,Cv,Camme)
      write(iuo,'(/," Simple binning:",/)') 
      write(iuo,'(" Camm =",5X,F10.6,2X,"+/-",F10.6)') Camm,Camme
      write(iuo,'(/," Jacknife binning:",/)') 
      call steb0(njob,Cjm,Cjmm,Cv,Cjmme)
      write(iuo,'(" Cjmm =",5X,F10.6,2X,"+/-",F10.6)') Cjmm,Cjmme
      call steb0(njob,Cmm,Cmmm,Cv,Cmmme)
      write(iuo,'(/," Bias corrected:",/)') 
      write(iuo,'(" Cmmm =",F10.6,2X,"+/-",F10.6,/)') Cmmm,Cmmme
      call heapsort(njob,Cam)
      call qdf_gnu(iud,njob,Cam)
      call heapsort(njob,Cjm)
      call qdf_gnu(iud,njob,Cjm)
      call heapsort(njob,Cmm)
      call qdf_gnu(iud,njob,Cmm)
C
      stop
      end

      include '../../Libs/Fortran/heapsort.f'
      include '../../Libs/Fortran/qdf_gnu.f'
      include '../../Libs/Fortran/razero.f'
      include '../../Libs/Fortran/stmean.f'
      include '../../Libs/Fortran/steb0.f'
