      subroutine potts_rwght(nlink,ha,hae,beta,beta0,hb,hbe)
C Bernd Berg Dec 13 2000. Reweighting beta -> beta0.
C Reweighting of the histogram ha() and its error bars hae() at beta 
C             to the histogram hb() and its error bars hbe() at beta0.
      include '../../Libs/Fortran/implicit.sta'
      include '../../Libs/Fortran/constants.par'
      dimension ha(0:nlink),hae(0:nlink),hb(0:nlink),hbe(0:nlink)
c
      hasum=zero
      act0m=zero
      do iact=0,nlink
        hasum=hasum+ha(iact)
        act0m=act0m+iact*ha(iact)
      end do
      act0m=act0m/hasum ! Used to avoid large arguments of exp().
c     
      hbsum=zero
      do iact=0,nlink
        hb(iact)=zero
        hbe(iact)=zero
        if(ha(iact).gt.em12) then
          a=(beta0-beta)*2*(iact-act0m)
          hb(iact)=exp(log(ha(iact))+a)
          hbe(iact)=exp(log(hae(iact))+a)
          hbsum=hbsum+hb(iact)
        end if ! Else hb(iact) is, as ha(iact), zero.
      end do
      factor=hasum/hbsum
      do iact=0,nlink
        hb(iact)=factor*hb(iact)
        hbe(iact)=factor*hbe(iact)
      end do
c     
      RETURN
      END
